## apex 1.6.10

=== Makefile ===
# APEX top-level Makefile
#   based on Linux Kernel Makefile 2.6.26-rc8

VERSION = 1
PATCHLEVEL = 6
SUBLEVEL = 10
#EXTRAVERSION = -$(shell date "+%j.%R:%S")
ARCH ?= arm

BUILDDATE = $(shell date "+%Y.%b.%d-%R:%S")
export BUILDDATE

# Preserve environment for the cross-compiler
ENV_CROSS_COMPILE:=$(CROSS_COMPILE)

# *DOCUMENTATION*
# To see a list of typical targets execute "make help"
# More info can be located in ./README
# Comments in this file are targeted only to the developer, do not
# expect to learn how to build the kernel reading this file.

# Do not:
# o  use make's built-in rules and variables
#    (this increases performance and avoids hard-to-debug behaviour);
# o  print "Entering directory ...";
MAKEFLAGS += -rR --no-print-directory

# We are using a recursive build, so we need to do a little thinking
# to get the ordering right.
#
# Most importantly: sub-Makefiles should only ever modify files in
# their own directory. If in some directory we have a dependency on
# a file in another dir (which doesn't happen often, but it's often
# unavoidable when linking the built-in.o targets which finally
# turn into apex), we will call a sub make in that other dir, and
# after that we are sure that everything which is in that other dir
# is now up to date.
#
# The only cases where we need to modify files which have global
# effects are thus separated out and done before the recursive
# descending is started. They are now explicitly listed as the
# prepare rule.

# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifdef V
  ifeq ("$(origin V)", "command line")
    KBUILD_VERBOSE = $(V)
  endif
endif
ifndef KBUILD_VERBOSE
  KBUILD_VERBOSE = 0
endif

# Call a source code checker (by default, "sparse") as part of the
# C compilation.
#
# Use 'make C=1' to enable checking of only re-compiled files.
# Use 'make C=2' to enable checking of *all* source files, regardless
# of whether they are re-compiled or not.
#
# See the file "Documentation/sparse.txt" for more details, including
# where to get the "sparse" utility.

ifdef C
  ifeq ("$(origin C)", "command line")
    KBUILD_CHECKSRC = $(C)
  endif
endif
ifndef KBUILD_CHECKSRC
  KBUILD_CHECKSRC = 0
endif

# Use make M=dir to specify directory of external module to build
# Old syntax make ... SUBDIRS=$PWD is still supported
# Setting the environment variable KBUILD_EXTMOD take precedence
ifdef SUBDIRS
  KBUILD_EXTMOD ?= $(SUBDIRS)
endif
ifdef M
  ifeq ("$(origin M)", "command line")
    KBUILD_EXTMOD := $(M)
  endif
endif


# kbuild supports saving output files in a separate directory.
# To locate output files in a separate directory two syntaxes are supported.
# In both cases the working directory must be the root of the kernel src.
# 1) O=
# Use "make O=dir/to/store/output/files/"
#
# 2) Set KBUILD_OUTPUT
# Set the environment variable KBUILD_OUTPUT to point to the directory
# where the output files shall be placed.
# export KBUILD_OUTPUT=dir/to/store/output/files/
# make
#
# The O= assignment takes precedence over the KBUILD_OUTPUT environment
# variable.


# KBUILD_SRC is set on invocation of make in OBJ directory
# KBUILD_SRC is not intended to be used by the regular user (for now)
ifeq ($(KBUILD_SRC),)

# OK, Make called in directory where kernel src resides
# Do we want to locate output files in a separate directory?
ifdef O
  ifeq ("$(origin O)", "command line")
    KBUILD_OUTPUT := $(O)
  endif
endif

# That's our default target when none is given on the command line
PHONY := _all
_all:

# Cancel implicit rules on top Makefile
$(CURDIR)/Makefile Makefile: ;

ifneq ($(KBUILD_OUTPUT),)
# Invoke a second make in the output directory, passing relevant variables
# check that the output directory actually exists
saved-output := $(KBUILD_OUTPUT)
KBUILD_OUTPUT := $(shell cd $(KBUILD_OUTPUT) && /bin/pwd)
$(if $(KBUILD_OUTPUT),, \
     $(error output directory "$(saved-output)" does not exist))

PHONY += $(MAKECMDGOALS) sub-make

$(filter-out _all sub-make $(CURDIR)/Makefile, $(MAKECMDGOALS)) _all: sub-make
	$(Q)@:

sub-make: FORCE
	$(if $(KBUILD_VERBOSE:1=),@)$(MAKE) -C $(KBUILD_OUTPUT) \
	KBUILD_SRC=$(CURDIR) \
	KBUILD_EXTMOD="$(KBUILD_EXTMOD)" -f $(CURDIR)/Makefile \
	$(filter-out _all sub-make,$(MAKECMDGOALS))

# Leave processing to above invocation of make
skip-makefile := 1
endif # ifneq ($(KBUILD_OUTPUT),)
endif # ifeq ($(KBUILD_SRC),)

# We process the rest of the Makefile if this is the final invocation of make
ifeq ($(skip-makefile),)

# If building an external module we do not care about the all: rule
# but instead _all depend on modules
PHONY += all
ifeq ($(KBUILD_EXTMOD),)
_all: all
else
_all: modules
endif

srctree		:= $(if $(KBUILD_SRC),$(KBUILD_SRC),$(CURDIR))
TOPDIR		:= $(srctree)
# FIXME - TOPDIR is obsolete, use srctree/objtree
objtree		:= $(CURDIR)
src		:= $(srctree)
obj		:= $(objtree)

VPATH		:= $(srctree)$(if $(KBUILD_EXTMOD),:$(KBUILD_EXTMOD))

export srctree objtree VPATH TOPDIR


# SUBARCH tells the usermode build what the underlying arch is.  That is set
# first, and if a usermode build is happening, the "ARCH=um" on the command
# line overrides the setting of ARCH below.  If a native build is happening,
# then ARCH is assigned, getting whatever value it gets normally, and 
# SUBARCH is subsequently ignored.

SUBARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ \
				  -e s/arm.*/arm/ -e s/sa110/arm/ \
				  -e s/s390x/s390/ -e s/parisc64/parisc/ \
				  -e s/ppc.*/powerpc/ -e s/mips.*/mips/ \
				  -e s/sh.*/sh/ )

# Cross compiling and selecting different set of gcc/bin-utils
# ---------------------------------------------------------------------------
#
# When performing cross compilation for other architectures ARCH shall be set
# to the target architecture. (See arch/* for the possibilities).
# ARCH can be set during invocation of make:
# make ARCH=ia64
# Another way is to have ARCH set in the environment.
# The default ARCH is the host where make is executed.

# CROSS_COMPILE specify the prefix used for all executables used
# during compilation. Only gcc and related bin-utils executables
# are prefixed with $(CROSS_COMPILE).
# CROSS_COMPILE can be set on the command line
# make CROSS_COMPILE=ia64-linux-
# Alternatively CROSS_COMPILE can be set in the environment.
# Default value for CROSS_COMPILE is not to prefix executables
# Note: Some architectures assign CROSS_COMPILE in their arch/*/Makefile
export KBUILD_BUILDHOST := $(SUBARCH)
ARCH		?= $(SUBARCH)
# *** elf: removed
#CROSS_COMPILE	?=

# Architecture as present in compile.h
UTS_MACHINE 	:= $(ARCH)
SRCARCH 	:= $(ARCH)

# Additional ARCH settings for x86
ifeq ($(ARCH),i386)
        SRCARCH := x86
endif
ifeq ($(ARCH),x86_64)
        SRCARCH := x86
endif

KCONFIG_CONFIG	?= .config

# SHELL used by kbuild
CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
	  else if [ -x /bin/bash ]; then echo /bin/bash; \
	  else echo sh; fi ; fi)

HOSTCC       = gcc
HOSTCXX      = g++
HOSTCFLAGS   = -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer
HOSTCXXFLAGS = -O2

# Decide whether to build built-in, modular, or both.
# Normally, just do built-in.

KBUILD_MODULES :=
KBUILD_BUILTIN := 1

#	If we have only "make modules", don't compile built-in objects.
#	When we're building modules with modversions, we need to consider
#	the built-in objects during the descend as well, in order to
#	make sure the checksums are up to date before we record them.

ifeq ($(MAKECMDGOALS),modules)
  KBUILD_BUILTIN := $(if $(CONFIG_MODVERSIONS),1)
endif

#	If we have "make <whatever> modules", compile modules
#	in addition to whatever we do anyway.
#	Just "make" or "make all" shall build modules as well

ifneq ($(filter all _all modules,$(MAKECMDGOALS)),)
  KBUILD_MODULES := 1
endif

ifeq ($(MAKECMDGOALS),)
  KBUILD_MODULES := 1
endif

export KBUILD_MODULES KBUILD_BUILTIN
export KBUILD_CHECKSRC KBUILD_SRC KBUILD_EXTMOD

# Beautify output
# ---------------------------------------------------------------------------
#
# Normally, we echo the whole command before executing it. By making
# that echo $($(quiet)$(cmd)), we now have the possibility to set
# $(quiet) to choose other forms of output instead, e.g.
#
#         quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
#         cmd_cc_o_c       = $(CC) $(c_flags) -c -o $@ $<
#
# If $(quiet) is empty, the whole command will be printed.
# If it is set to "quiet_", only the short version will be printed. 
# If it is set to "silent_", nothing will be printed at all, since
# the variable $(silent_cmd_cc_o_c) doesn't exist.
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#	$(Q)ln $@ :<
#
# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
# If KBUILD_VERBOSE equals 1 then the above command is displayed.

ifeq ($(KBUILD_VERBOSE),1)
  quiet =
  Q =
else
  quiet=quiet_
  Q = @
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands

ifneq ($(findstring s,$(MAKEFLAGS)),)
  quiet=silent_
endif

export quiet Q KBUILD_VERBOSE


# Look for make include files relative to root of kernel src
MAKEFLAGS += --include-dir=$(srctree)

# We need some generic definitions (do not try to remake the file).
$(srctree)/scripts/Kbuild.include: ;
include $(srctree)/scripts/Kbuild.include

# Make variables (CC, etc...)

AS		= $(CROSS_COMPILE_)as
LD		= $(CROSS_COMPILE_)ld
CC		= $(CROSS_COMPILE_)gcc
CPP		= $(CC) -E
AR		= $(CROSS_COMPILE_)ar
NM		= $(CROSS_COMPILE_)nm
STRIP		= $(CROSS_COMPILE_)strip
OBJCOPY		= $(CROSS_COMPILE_)objcopy
OBJDUMP		= $(CROSS_COMPILE_)objdump
AWK		= awk
GENKSYMS	= scripts/genksyms/genksyms
DEPMOD		= /sbin/depmod
KALLSYMS	= scripts/kallsyms
PERL		= perl
CHECK		= sparse

CHECKFLAGS     := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ -Wbitwise $(CF)
MODFLAGS	= -DMODULE
CFLAGS_MODULE   = $(MODFLAGS)
AFLAGS_MODULE   = $(MODFLAGS)
LDFLAGS_MODULE  =
CFLAGS_KERNEL	=
AFLAGS_KERNEL	=


# Use LINUXINCLUDE when you must reference the include/ directory.
# Needed to be compatible with the O= option
LINUXINCLUDE    := -Iinclude \
                   $(if $(KBUILD_SRC),-Iinclude2 -I$(srctree)/include) \
		   -include include/linux/autoconf.h

KBUILD_CPPFLAGS := -D__KERNEL__ $(LINUXINCLUDE)

KBUILD_CFLAGS   := -Wall -Wundef -Wstrict-prototypes -Wno-trigraphs \
		   -fno-strict-aliasing -fno-common \
		   -Werror-implicit-function-declaration \
		   -fno-builtin-printf
KBUILD_AFLAGS   := -D__ASSEMBLY__

# Read KERNELRELEASE from include/config/kernel.release (if it exists)
#KERNELRELEASE = $(shell cat include/config/kernel.release 2> /dev/null)
#KERNELVERSION = $(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)
APEXVERSION = $(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)

export VERSION PATCHLEVEL SUBLEVEL APEXVERSION
export ARCH SRCARCH CONFIG_SHELL HOSTCC HOSTCFLAGS CROSS_COMPILE AS LD CC
export CPP AR NM STRIP OBJCOPY OBJDUMP MAKE AWK GENKSYMS PERL UTS_MACHINE
export HOSTCXX HOSTCXXFLAGS LDFLAGS_MODULE CHECK CHECKFLAGS

export KBUILD_CPPFLAGS NOSTDINC_FLAGS LINUXINCLUDE OBJCOPYFLAGS LDFLAGS
export KBUILD_CFLAGS CFLAGS_KERNEL CFLAGS_MODULE
export KBUILD_AFLAGS AFLAGS_KERNEL AFLAGS_MODULE

# When compiling out-of-tree modules, put MODVERDIR in the module
# tree rather than in the kernel tree. The kernel tree might
# even be read-only.
export MODVERDIR := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_versions

# Files to ignore in find ... statements

RCS_FIND_IGNORE := \( -name SCCS -o -name BitKeeper -o -name .svn -o -name CVS -o -name .pc -o -name .hg -o -name .git \) -prune -o
export RCS_TAR_IGNORE := --exclude SCCS --exclude BitKeeper --exclude .svn --exclude CVS --exclude .pc --exclude .hg --exclude .git

# ===========================================================================
# Rules shared between *config targets and build targets

# Basic helpers built in scripts/
PHONY += scripts_basic
scripts_basic:

=== arm-kernel-shim/Makefile ===
# Makefile
#
#   Copyright (C) 2008 Marc Singer
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License
#   version 2 as published by the Free Software Foundation.
#   Please refer to the file debian/copyright for further details.
#

PACKAGE:=arm-kernel-shim
VERSION:=1.5

CROSS_COMPILE:=/usr/arm-linux/gcc3/arm-linux-
CC=$(CROSS_COMPILE)gcc
LD=$(CROSS_COMPILE)ld
OBJCOPY=$(CROSS_COMPILE)objcopy

CFLAGS:=-g -Os -nostartfiles -nostdlib
LDFLAGS:= -g -Ttext 0 -X -Map shim.map

SRCS:= shim.lds main.c
OBJS:=$(SRCS:.c=.o)

all: $(PACKAGE).bin $(PACKAGE).bin-swapped

$(PACKAGE).bin: $(PACKAGE)
	$(OBJCOPY) -O binary -R .bss -R .comment $< $@

$(PACKAGE).bin-swapped: $(PACKAGE).bin
	cat $< | ./wordswap > $@

$(PACKAGE): $(OBJS)
	$(LD) $(LDFLAGS) $(OBJS) -o $@

%.o: %.c
	$(CC) -c $(CFLAGS) $< -o $@

%.s: %.c
	$(CC) -S $(CFLAGS) $< -o $@


.PHONY: clean
clean:
	-rm *.o $(PACKAGE) $(PACKAGE).bin *~ *.map

.PHONY: tag
tag:
	svn cp file:///svn/tools/trunk/apex/$(PACKAGE)\
	       file:///svn/tools/tags/$(PACKAGE)/$(VERSION)

.PHONY: remove-tag
remove-tag:
	svn rm file:///svn/tools/tags/$(PACKAGE)/$(VERSION)

.PHONY: package
package: $(PACKAGE)-$(VERSION).tar.gz

$(PACKAGE)-$(VERSION).tar.gz:
	[ ! -d $(PACKAGE)-$(VERSION) ] || rm -rf $(PACKAGE)-$(VERSION)
	svn export -q file:///svn/tools/tags/$(PACKAGE)/$(VERSION)\
	  $(PACKAGE)-$(VERSION)
	tar zcvf $(PACKAGE)-$(VERSION).tar.gz $(PACKAGE)-$(VERSION)
	rm -rf $(PACKAGE)-$(VERSION)

=== scripts/Makefile ===
###
# scripts contains sources for various helper programs used throughout
# the kernel for the build process.
# ---------------------------------------------------------------------------
# kallsyms:      Find all symbols in vmlinux
# pnmttologo:    Convert pnm files to logo files
# conmakehash:   Create chartable
# conmakehash:	 Create arrays for initializing the kernel console tables

hostprogs-$(CONFIG_KALLSYMS)     += kallsyms
hostprogs-$(CONFIG_LOGO)         += pnmtologo
hostprogs-$(CONFIG_VT)           += conmakehash
hostprogs-$(CONFIG_PROM_CONSOLE) += conmakehash
hostprogs-$(CONFIG_IKCONFIG)     += bin2c

always		:= $(hostprogs-y) $(hostprogs-m)

# The following hostprogs-y programs are only build on demand
hostprogs-y += unifdef

subdir-$(CONFIG_MODVERSIONS) += genksyms
#subdir-y                     += mod

# Let clean descend into subdirs
subdir-	+= basic kconfig package

=== usr/Makefile ===
# Makefile

#CROSS_COMPILE ?= /usr/arm-linux/gcc3/arm-linux-
#CFLAGS ?= -I/a/trans/embedded/m3/tools-target/usr/include
#LDFLAGS ?= -L/a/trans/embedded/m3/tools-target/usr/lib

CFLAGS += -I../include

apex-env_SRCS:=apex-env.cc mtdpartition.cc link.cc
apex-env_OBJS:=$(apex-env_SRCS:.cc=.o)

apex-image_SRCS:=apex-image.cc dumpw.cc
apex-image_OBJS:=$(apex-image_SRCS:.cc=.o)

DEPS:=$(apex-env_SRCS:%.cc=%.d)

CC=$(CROSS_COMPILE)g++
CXX=$(CROSS_COMPILE)g++
LD=$(CROSS_COMPILE)ld
STRIP=$(CROSS_COMPILE)strip

CFLAGS+= -Wall -Os -g -c
CFLAGS_LINK+= -g

TARGETS:=apex-env apex-image

.PHONY: all
all: $(TARGETS) groom

apex-env: $(apex-env_OBJS)
	@echo linking $@
	@$(CC) $(CFLAGS_LINK) -o $@ $^ $(LIBRARIES) $($@_LIB)

apex-image: $(apex-image_OBJS)
	@echo linking $@
	@$(CC) $(CFLAGS_LINK) -o $@ $^ $(LIBRARIES) $($@_LIB)

%.o: %.cc
	@echo compile $<
	@$(CXX) $(CFLAGS) -o $@ $<

%.d: %.cc
	@set -e; rm -f $@; \
          $(CXX) -MM $(CFLAGS) $< > $@.$$$$; \
          sed 's,\($*\)\.o[ :]*,\1.o $@ : ,g' < $@.$$$$ > $@; \
          rm -f $@.$$$$

.PHONY: clean
clean:
	-rm $(wildcard $(TARGETS) *.o *.d)

CRUFT:=$(wildcard  *.d.*)

.PHONY: groom
groom:
ifneq ($(CRUFT),)
	@rm $(CRUFT)
endif

-include $(DEPS)

=== scripts/kconfig/Makefile ===
# ===========================================================================
# Kernel configuration targets
# These targets are used from top-level makefile

PHONY += oldconfig xconfig gconfig menuconfig config silentoldconfig update-po-config

Kconfig := src/arch-$(SRCARCH)/Kconfig

xconfig: $(obj)/qconf
	$< $(Kconfig)

gconfig: $(obj)/gconf
	$< $(Kconfig)

menuconfig: $(obj)/mconf
	$< $(Kconfig)

config: $(obj)/conf
	$< $(Kconfig)

oldconfig: $(obj)/conf
	$< -o $(Kconfig)

silentoldconfig: $(obj)/conf
	$< -s $(Kconfig)

# Create new linux.pot file
# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
# The symlink is used to repair a deficiency in arch/um
update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
	$(Q)echo "  GEN config"
	$(Q)xgettext --default-domain=linux              \
	    --add-comments --keyword=_ --keyword=N_      \
	    --from-code=UTF-8                            \
	    --files-from=scripts/kconfig/POTFILES.in     \
	    --output $(obj)/config.pot
	$(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
	$(Q)ln -fs Kconfig.i386 arch/um/Kconfig.arch
	$(Q)(for i in `ls arch/*/Kconfig`;               \
	    do                                           \
		echo "  GEN $$i";                        \
		$(obj)/kxgettext $$i                     \
		     >> $(obj)/config.pot;               \
	    done )
	$(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
	    --output $(obj)/linux.pot
	$(Q)rm -f arch/um/Kconfig.arch
	$(Q)rm -f $(obj)/config.pot

PHONY += randconfig allyesconfig allnoconfig allmodconfig defconfig

randconfig: $(obj)/conf
	$< -r $(Kconfig)

allyesconfig: $(obj)/conf
	$< -y $(Kconfig)

allnoconfig: $(obj)/conf
	$< -n $(Kconfig)

allmodconfig: $(obj)/conf
	$< -m $(Kconfig)

defconfig: $(obj)/conf
ifeq ($(KBUILD_DEFCONFIG),)
	$< -d $(Kconfig)
else
	@echo "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
	$(Q)$< -D src/arch-$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
endif

%_config: $(obj)/conf
	$(Q)$< -D src/mach-*/$@ $(Kconfig)

# Help text used by make help
help:
	@echo  '  config	  - Update current config utilising a line-oriented program'
	@echo  '  menuconfig	  - Update current config utilising a menu based program'
	@echo  '  xconfig	  - Update current config utilising a QT based front-end'
	@echo  '  gconfig	  - Update current config utilising a GTK based front-end'
	@echo  '  oldconfig	  - Update current config utilising a provided .config as base'
	@echo  '  silentoldconfig - Same as oldconfig, but quietly'
	@echo  '  randconfig	  - New config with random answer to all options'
	@echo  '  defconfig	  - New config with default answer to all options'
	@echo  '  allmodconfig	  - New config selecting modules when possible'
	@echo  '  allyesconfig	  - New config where all options are accepted with yes'
	@echo  '  allnoconfig	  - New config where all options are answered with no'

# lxdialog stuff
check-lxdialog  := $(srctree)/$(src)/lxdialog/check-lxdialog.sh

# Use recursively expanded variables so we do not call gcc unless
# we really need to do so. (Do not call gcc as part of make mrproper)
HOST_EXTRACFLAGS = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags)
HOST_LOADLIBES   = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))

HOST_EXTRACFLAGS += -DLOCALE


# ===========================================================================
# Shared Makefile for the various kconfig executables:
# conf:	  Used for defconfig, oldconfig and related targets
# mconf:  Used for the mconfig target.
#         Utilizes the lxdialog package
# qconf:  Used for the xconfig target
#         Based on QT which needs to be installed to compile it
# gconf:  Used for the gconfig target
#         Based on GTK which needs to be installed to compile it
# object files used by all kconfig flavours

lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o

conf-objs	:= conf.o  zconf.tab.o
mconf-objs	:= mconf.o zconf.tab.o $(lxdialog)
kxgettext-objs	:= kxgettext.o zconf.tab.o

hostprogs-y := conf qconf gconf kxgettext

ifeq ($(MAKECMDGOALS),menuconfig)
	hostprogs-y += mconf
endif

ifeq ($(MAKECMDGOALS),xconfig)
	qconf-target := 1
endif
ifeq ($(MAKECMDGOALS),gconfig)
	gconf-target := 1
endif


ifeq ($(qconf-target),1)
qconf-cxxobjs	:= qconf.o
qconf-objs	:= kconfig_load.o zconf.tab.o
endif

ifeq ($(gconf-target),1)
gconf-objs	:= gconf.o kconfig_load.o zconf.tab.o
endif

clean-files	:= lkc_defs.h qconf.moc .tmp_qtcheck \
		   .tmp_gtkcheck zconf.tab.c lex.zconf.c zconf.hash.c gconf.glade.h
clean-files     += mconf qconf gconf
clean-files     += config.pot linux.pot

# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
PHONY += $(obj)/dochecklxdialog
$(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
$(obj)/dochecklxdialog:
	$(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOST_LOADLIBES)

always := dochecklxdialog

# Add environment specific flags
HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))

# generated files seem to need this to find local include files
HOSTCFLAGS_lex.zconf.o	:= -I$(src)
HOSTCFLAGS_zconf.tab.o	:= -I$(src)

HOSTLOADLIBES_qconf	= $(KC_QT_LIBS) -ldl
HOSTCXXFLAGS_qconf.o	= $(KC_QT_CFLAGS) -D LKC_DIRECT_LINK

HOSTLOADLIBES_gconf	= `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
HOSTCFLAGS_gconf.o	= `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
                          -D LKC_DIRECT_LINK

$(obj)/qconf.o: $(obj)/.tmp_qtcheck

ifeq ($(qconf-target),1)
$(obj)/.tmp_qtcheck: $(src)/Makefile
-include $(obj)/.tmp_qtcheck

# QT needs some extra effort...
$(obj)/.tmp_qtcheck:
	@set -e; echo "  CHECK   qt"; dir=""; pkg=""; \
	pkg-config --exists qt 2> /dev/null && pkg=qt; \
	pkg-config --exists qt-mt 2> /dev/null && pkg=qt-mt; \
	if [ -n "$$pkg" ]; then \
	  cflags="\$$(shell pkg-config $$pkg --cflags)"; \
	  libs="\$$(shell pkg-config $$pkg --libs)"; \
	  moc="\$$(shell pkg-config $$pkg --variable=prefix)/bin/moc"; \
	  dir="$$(pkg-config $$pkg --variable=prefix)"; \
	else \
	  for d in $$QTDIR /usr/share/qt* /usr/lib/qt*; do \
	    if [ -f $$d/include/qconfig.h ]; then dir=$$d; break; fi; \
	  done; \
	  if [ -z "$$dir" ]; then \
	    echo "*"; \
	    echo "* Unable to find the QT3 installation. Please make sure that"; \
	    echo "* the QT3 development package is correctly installed and"; \
	    echo "* either install pkg-config or set the QTDIR environment"; \
	    echo "* variable to the correct location."; \
	    echo "*"; \
	    false; \
	  fi; \
	  libpath=$$dir/lib; lib=qt; osdir=""; \
	  $(HOSTCXX) -print-multi-os-directory > /dev/null 2>&1 && \
	    osdir=x$$($(HOSTCXX) -print-multi-os-directory); \
	  test -d $$libpath/$$osdir && libpath=$$libpath/$$osdir; \
	  test -f $$libpath/libqt-mt.so && lib=qt-mt; \
	  cflags="-I$$dir/include"; \
	  libs="-L$$libpath -Wl,-rpath,$$libpath -l$$lib"; \
	  moc="$$dir/bin/moc"; \
	fi; \
	if [ ! -x $$dir/bin/moc -a -x /usr/bin/moc ]; then \
	  echo "*"; \
	  echo "* Unable to find $$dir/bin/moc, using /usr/bin/moc instead."; \
	  echo "*"; \
	  moc="/usr/bin/moc"; \
	fi; \
	echo "KC_QT_CFLAGS=$$cflags" > $@; \
	echo "KC_QT_LIBS=$$libs" >> $@; \
	echo "KC_QT_MOC=$$moc" >> $@
endif

$(obj)/gconf.o: $(obj)/.tmp_gtkcheck

ifeq ($(gconf-target),1)
-include $(obj)/.tmp_gtkcheck

# GTK needs some extra effort, too...
$(obj)/.tmp_gtkcheck:
	@if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then		\
		if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then			\
			touch $@;								\
		else									\
			echo "*"; 							\
			echo "* GTK+ is present but version >= 2.0.0 is required.";	\
			echo "*";							\
			false;								\
		fi									\
	else										\
		echo "*"; 								\
		echo "* Unable to find the GTK+ installation. Please make sure that"; 	\
		echo "* the GTK+ 2.0 development package is correctly installed..."; 	\
		echo "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; 		\
		echo "*"; 								\
		false;									\
	fi
endif

$(obj)/zconf.tab.o: $(obj)/lex.zconf.c $(obj)/zconf.hash.c

$(obj)/kconfig_load.o: $(obj)/lkc_defs.h

$(obj)/qconf.o: $(obj)/qconf.moc $(obj)/lkc_defs.h

$(obj)/gconf.o: $(obj)/lkc_defs.h

$(obj)/%.moc: $(src)/%.h
	$(KC_QT_MOC) -i $< -o $@

$(obj)/lkc_defs.h: $(src)/lkc_proto.h
	sed < $< > $@ 's/P(\([^,]*\),.*/#define \1 (\*\1_p)/'

# Extract gconf menu items for I18N support
$(obj)/gconf.glade.h: $(obj)/gconf.glade
	intltool-extract --type=gettext/glade $(obj)/gconf.glade

###
# The following requires flex/bison/gperf
# By default we use the _shipped versions, uncomment the following line if
# you are modifying the flex/bison src.
# LKC_GENPARSER := 1

ifdef LKC_GENPARSER

$(obj)/zconf.tab.c: $(src)/zconf.y
$(obj)/lex.zconf.c: $(src)/zconf.l
$(obj)/zconf.hash.c: $(src)/zconf.gperf

%.tab.c: %.y
	bison -l -b $* -p $(notdir $*) $<
	cp $@ $@_shipped

lex.%.c: %.l
	flex -L -P$(notdir $*) -o$@ $<
	cp $@ $@_shipped

%.hash.c: %.gperf
	gperf < $< > $@
	cp $@ $@_shipped

endif

=== scripts/package/Makefile ===
# Makefile for the different targets used to generate full packages of a kernel
# It uses the generic clean infrastructure of kbuild

# Ignore the following files/directories during tar operation
TAR_IGNORE := --exclude SCCS --exclude BitKeeper --exclude .svn --exclude CVS

PKGBASE := apex-$(APEXVERSION)

.PHONY: tgz.pkg
tgz.pkg tgz:
ifneq "$(wildcard $(PKGBASE))" ""
	-rm -rf $(PKGBASE)
endif
	@git-clone -l ./ $(PKGBASE)
	find $(PKGBASE) -depth -type d -name '_intel' -exec rm -rf \{\} \;
	rm -rf $(PKGBASE)/include/splash
	tar zc\
	 --exclude='.git'\
	 --exclude='cc-png.h'\
	 --exclude='pcm*-*.h'\
	 --exclude='colorbars*.png'\
	 -f $(PKGBASE).tar.gz $(PKGBASE)
	@rm -rf $(PKGBASE)

help:
	@echo '  tgz             - Build a tar.gz file of the source'

# RPM target
# ---------------------------------------------------------------------------
# The rpm target generates two rpm files:
# /usr/src/packages/SRPMS/kernel-2.6.7rc2-1.src.rpm
# /usr/src/packages/RPMS/i386/kernel-2.6.7rc2-1.<arch>.rpm
# The src.rpm files includes all source for the kernel being built
# The <arch>.rpm includes kernel configuration, modules etc.
#
# Process to create the rpm files
# a) clean the kernel
# b) Generate .spec file
# c) Build a tar ball, using symlink to make kernel version
#    first entry in the path
# d) and pack the result to a tar.gz file
# e) generate the rpm files, based on kernel.spec
# - Use /. to avoid tar packing just the symlink

# Do we have rpmbuild, otherwise fall back to the older rpm
RPM := $(shell if [ -x "/usr/bin/rpmbuild" ]; then echo rpmbuild; \
	           else echo rpm; fi)

# Remove hyphens since they have special meaning in RPM filenames
KERNELPATH := kernel-$(subst -,,$(KERNELRELEASE))
MKSPEC     := $(srctree)/scripts/package/mkspec
PREV       := set -e; cd ..;

# rpm-pkg
# ---------------------------------------------------------------------------
$(objtree)/kernel.spec: $(MKSPEC) $(srctree)/Makefile
	$(CONFIG_SHELL) $(MKSPEC) > $@

rpm-pkg rpm: $(objtree)/kernel.spec FORCE
	$(MAKE) clean
	$(PREV) ln -sf $(srctree) $(KERNELPATH)
	$(PREV) tar -cz $(RCS_TAR_IGNORE) -f $(KERNELPATH).tar.gz $(KERNELPATH)/.
	$(PREV) rm $(KERNELPATH)

	set -e; \
	$(CONFIG_SHELL) $(srctree)/scripts/mkversion > $(objtree)/.tmp_version
	set -e; \
	mv -f $(objtree)/.tmp_version $(objtree)/.version

	$(RPM) --target $(UTS_MACHINE) -ta ../$(KERNELPATH).tar.gz
	rm ../$(KERNELPATH).tar.gz

clean-files := $(objtree)/kernel.spec

# binrpm-pkg
# ---------------------------------------------------------------------------
$(objtree)/binkernel.spec: $(MKSPEC) $(srctree)/Makefile
	$(CONFIG_SHELL) $(MKSPEC) prebuilt > $@

binrpm-pkg: $(objtree)/binkernel.spec FORCE
	$(MAKE) KBUILD_SRC=
	set -e; \
	$(CONFIG_SHELL) $(srctree)/scripts/mkversion > $(objtree)/.tmp_version
	set -e; \
	mv -f $(objtree)/.tmp_version $(objtree)/.version

	$(RPM) --define "_builddir $(srctree)" --target $(UTS_MACHINE) -bb $<

clean-files += $(objtree)/binkernel.spec

# Deb target
# ---------------------------------------------------------------------------
deb-pkg: FORCE
	$(MAKE) KBUILD_SRC=
	$(CONFIG_SHELL) $(srctree)/scripts/package/builddeb

# *** elf: removed because it clobbers our Debian files.
#clean-dirs += $(objtree)/debian/


# tarball targets
# ---------------------------------------------------------------------------
tar%pkg: FORCE
	$(MAKE) KBUILD_SRC=
	$(CONFIG_SHELL) $(srctree)/scripts/package/buildtar $@

clean-dirs += $(objtree)/tar-install/


# Help text displayed when executing 'make help'
# ---------------------------------------------------------------------------
help: FORCE
	@echo '  rpm-pkg         - Build both source and binary RPM kernel packages'
	@echo '  binrpm-pkg      - Build only the binary kernel package'
	@echo '  deb-pkg         - Build the kernel as an deb package'
	@echo '  tar-pkg         - Build the kernel as an uncompressed tarball'
	@echo '  targz-pkg       - Build the kernel as a gzip compressed tarball'
	@echo '  tarbz2-pkg      - Build the kernel as a bzip2 compressed tarball'

=== src/apex/Makefile ===
#
# Makefile for APEX loader
#
#   Copyright (C) 2004 Marc Singer
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License
#   version 2 as published by the Free Software Foundation.
#   Please refer to the file debian/copyright for further details.
#

obj-y := init.o services.o console.o console-printf.o
obj-y += command.o cmd-version.o cmd-help.o cmd-boot.o
obj-y += region-copy.o region-checksum.o

obj-$(CONFIG_COMMAND_HISTORY)   += command-history.o

obj-$(CONFIG_ENV)		+= env.o

obj-$(CONFIG_CMD_ALIAS)		+= cmd-alias.o
obj-$(CONFIG_CMD_CHECKSUM)	+= cmd-checksum.o
obj-$(CONFIG_CMD_COMPARE)	+= cmd-compare.o
obj-$(CONFIG_CMD_COPY)		+= cmd-copy.o
obj-$(CONFIG_CMD_DRVINFO)	+= cmd-drvinfo.o
obj-$(CONFIG_CMD_DUMP)		+= cmd-dump.o
obj-$(CONFIG_CMD_ECHO)		+= cmd-echo.o
obj-$(CONFIG_CMD_ENV)		+= cmd-env.o
obj-$(CONFIG_CMD_ERASE)		+= cmd-erase.o
obj-$(CONFIG_CMD_FILL)		+= cmd-fill.o
obj-$(CONFIG_CMD_GO)		+= cmd-go.o
obj-$(CONFIG_CMD_INFO)		+= cmd-info.o
obj-$(CONFIG_CMD_MEMTEST)	+= cmd-memtest.o
obj-$(CONFIG_CMD_PAUSE)		+= cmd-pause.o
obj-$(CONFIG_CMD_PARSE)		+= cmd-parse.o
obj-$(CONFIG_CMD_WAIT)		+= cmd-wait.o
obj-$(CONFIG_CMD_XRECEIVE)	+= cmd-xreceive.o
obj-$(CONFIG_CMD_IMAGE)		+= cmd-image.o
obj-$(CONFIG_CMD_IMAGE_APEX)	+= cmd-image-apex.o
obj-$(CONFIG_CMD_IMAGE_UBOOT)	+= cmd-image-uboot.o
obj-$(CONFIG_CMD_FLASHUSAGE)	+= cmd-flashusage.o

ifneq ($(CONFIG_THUMB),)
 EXTRA_CFLAGS += -mthumb
endif

CFLAGS_cmd-version.o += -DAPEXVERSION=\"$(APEXVERSION)\"
CFLAGS_env.o	     += -DAPEXVERSION=\"$(APEXVERSION)\"

ifdef BUILDDATE
CFLAGS_cmd-version.o += -DBUILDDATE=\"$(BUILDDATE)\"
CFLAGS_env.o	     += -DBUILDDATE=\"$(BUILDDATE)\"
endif

=== src/arch-arm/Makefile ===
#
# Makefile for APEX loader
#
#   Copyright (C) 2004 Marc Singer
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License
#   version 2 as published by the Free Software Foundation.
#   Please refer to the file debian/copyright for further details.
#

LDFLAGS_apex := -p --no-undefined -X -g
OBJCOPYFLAGS := -O binary -R .note -R .comment -R .bss
GZFLAGS      := -9

# *** This lets the clean target work, but I'm not sure it's a good
# idea to include it.
-include .config
quote:="
# "
CONFIG_MACH:= $(subst $(quote),,$(CONFIG_MACH))

arch-$(CONFIG_CPU_ARMV4)   :=-D__LINUX_ARM_ARCH__=4 -march=armv4t
arch-$(CONFIG_CPU_ARMV5)   :=-D__LINUX_ARM_ARCH__=5 $(call cc-option,-march=armv5te,-march=armv4)
arch-$(CONFIG_CPU_ARMV6)   :=-D__LINUX_ARM_ARCH__=6 $(call cc-option,-march=armv6,-march=armv5t -Wa$(comma)-march=armv6)

tune-$(CONFIG_CPU_ARM720T) :=-mtune=arm7tdmi
tune-$(CONFIG_CPU_ARM920T) :=-mtune=arm9tdmi
tune-$(CONFIG_CPU_ARM922T) :=-mtune=arm9tdmi
tune-$(CONFIG_CPU_ARM925T) :=-mtune=arm9tdmi
tune-$(CONFIG_CPU_ARM926T) :=-mtune=arm9tdmi
tune-$(CONFIG_CPU_XSCALE)  :=$(call cc-option,-mtune=xscale,-mtune=strongarm110) -Wa,-mcpu=xscale
tune-$(CONFIG_CPU_ARMV6)   :=$(call cc-option,-mtune=arm1136j-s,-mtune=strongarm)

KBUILD_CFLAGS+= $(arch-y) $(tune-y) -Wall

ifneq ($(CONFIG_THUMB),)
 KBUILD_CFLAGS += -mthumb-interwork
 KBUILD_AFLAGS += -mthumb-interwork
endif

init-y += src/arch-arm/entry/
ifneq ($(CONFIG_MACH),)
core-y += src/mach-$(CONFIG_MACH)/
endif
core-y += src/drivers/ src/net/ src/arch-arm/linux/
core-$(CONFIG_DRIVERS_LH) +=  src/drivers-lh/
libs-y += src/arch-arm/lib/

ifneq ($(CONFIG_MACH),)
-include src/mach-$(CONFIG_MACH)/Makefile.libs
endif

rom := src/arch-arm/rom

apex.bin apex.bin_swap apex.elf apex.srec :\
		 include/config.h apex
	$(Q)$(MAKE) $(build)=$(rom) $(rom)/$@

=== src/drivers-lh/Makefile ===
#
# Makefile for APEX loader
#
#   Copyright (C) 2004,2005 Marc Singer
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License
#   version 2 as published by the Free Software Foundation.
#   Please refer to the file debian/copyright for further details.
#

obj-$(CONFIG_DRIVER_LH_ADC)	+= adc.o
obj-$(CONFIG_DRIVER_LH_MMC)	+= drv-mmc.o
obj-$(CONFIG_DRIVER_LH_CLCDC)	+= drv-clcdc.o
obj-$(CONFIG_DRIVER_LH_I2C)	+= drv-i2c.o

=== src/drivers/Makefile ===
#
# Makefile for APEX loader
#
#   Copyright (C) 2004 Marc Singer
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License
#   version 2 as published by the Free Software Foundation.
#   Please refer to the file debian/copyright for further details.
#


obj-y := driver.o
obj-y += drv-mem.o

obj-$(CONFIG_DRIVER_FAT)		+= drv-fat.o
obj-$(CONFIG_DRIVER_EXT2)		+= drv-ext2.o
obj-$(CONFIG_DRIVER_JFFS2)		+= drv-jffs2.o
obj-$(CONFIG_DRIVER_NOR_CFI)		+= drv-nor-cfi.o
obj-$(CONFIG_DRIVER_COMPACTFLASH)	+= drv-cf.o
obj-$(CONFIG_DRIVER_SMC91X)		+= drv-smc91x.o
obj-$(CONFIG_CMD_ETH_DM9000)		+= drv-dm9000.o
obj-$(CONFIG_DRIVER_DM9000)		+= drv-dm9000.o
obj-$(CONFIG_DRIVER_FIS)		+= drv-fis.o
obj-$(CONFIG_DRIVER_NAND)		+= drv-nand.o
obj-$(CONFIG_RELOCATE_NAND)		+= relocate-nand.o
obj-$(CONFIG_DRIVER_ONENAND)		+= drv-onenand.o
obj-$(CONFIG_RELOCATE_ONENAND)		+= relocate-onenand.o

obj-$(CONFIG_IXP4XX_NPE)		+= ixp4xx-npe/

ifneq ($(CONFIG_THUMB),)
 CFLAGS_driver.o	+= -mthumb
 CFLAGS_drv-fat.o	+= -mthumb
 CFLAGS_drv-ext2.o	+= -mthumb
 CFLAGS_drv-jffs2.o	+= -mthumb
 CFLAGS_drv-nor_cfi.o	+= -mthumb
 CFLAGS_drv-cf.o	+= -mthumb
 CFLAGS_drv-smc91x.o	+= -mthumb
 CFLAGS_drv-dm9000.o	+= -mthumb
 CFLAGS_drv-fis.o	+= -mthumb
 CFLAGS_drv-nand.o	+= -mthumb
 CFLAGS_drv-onenand.o	+= -mthumb
 CFLAGS_drv-nor-cfi.o	+= -mthumb
 CFLAGS_drv-mem.o	+= -mthumb
endif

=== src/lib/Makefile ===
#
# Makefile for APEX loader
#
#   Copyright (C) 2004 Marc Singer
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License
#   version 2 as published by the Free Software Foundation.
#   Please refer to the file debian/copyright for further details.
#

lib-y := vsprintf.o ctype.o strtol.o
lib-y += strlen.o strnlen.o strchr.o strlcpy.o strcat.o strcpy.o
lib-y += strcmp.o strnicmp.o strcspn.o
lib-y += memcmp.o memset.o
lib-y += memcpy.o
#lib-$(CONFIG_SMALL) += memcpy.o
lib-$(CONFIG_SMALL) += memmove.o
#lib-$(CONFIG_THUMB) += memcpy.o
lib-y += crc32.o xmodem.o
lib-$(CONFIG_CRC32_LSB) += crc32-lsb.o
lib-y += spinner.o
lib-$(CONFIG_ENV) += env.o
lib-y += dump.o
lib-y += zlib.o zlib-heap.o
#lib-y += png.o
lib-y += pngr.o
lib-y += sort.o
lib-$(CONFIG_ALIASES) += alias.o
lib-y += lookup.o
lib-y += memtest.o
lib-y += strimatch.o
lib-y += gmtime.o
lib-y += describe-size.o

ifneq ($(CONFIG_THUMB),)
  EXTRA_CFLAGS += -mthumb
endif

#lib-y += div64.o
#lib-y += udiv.o

=== src/mach-ixp42x/Makefile ===
#
# Makefile for APEX loader
#
#   Copyright (C) 2004 Marc Singer
#
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License
#   version 2 as published by the Free Software Foundation.
#   Please refer to the file debian/copyright for further details.
#

# npe-interface is in a world of it's own.  It has to build with
#   headers from the Intel Access Library which are incompatible with
#   header in the project.  So, it is isolated from the loader and
#   wrapper calls are defined to allow the header domain of the this
#   one source file to be separate from the header domain of the rest
#   of the application.

CFLAGS_npe-interface.o\
  += -I-\
     -Isrc/mach-ixp42x/_intel/ixp400_xscale_sw/src/include \
     -Isrc/mach-ixp42x/_intel/ixp_osal/include\
     -Isrc/mach-ixp42x/_intel/ixp_osal/os/linux/include/core\
     -Isrc/mach-ixp42x/_intel/ixp_osal/os/linux/include/modules/bufferMgt\
     -Isrc/mach-ixp42x/_intel/ixp_osal/os/linux/include/platforms/ixp400\
     -Isrc/mach-ixp42x/_intel/ixp_osal/include/modules/ioMem\
     -Isrc/mach-ixp42x/_intel/ixp_osal/include/modules/bufferMgt\
     -Isrc/mach-ixp42x/_intel/ixp_osal/include/platforms/ixp400\
     -Isrc/mach-ixp42x/_intel/ixp_osal/include/platforms/ixp400/bufferMgt\
     -Isrc/mach-ixp42x/_intel/linux/include\
     -Isrc/mach-ixp42x/_intel/linux/include/linux\
     -Isrc/mach-ixp42x/_intel/linux/include/asm/arch\
     -Isrc/mach-ixp42x/_intel/ixp400_xscale_sw/npeLib

obj-y := serial.o env.o cpuinfo.o
obj-y += initialize.o timer.o pci.o
obj-$(CONFIG_MMU) += initialize-sdram.o

obj-x$(CONFIG_MACH_NSLU2)$(CONFIG_SPINNER) += spinner-nslu2.o
obj-x$(CONFIG_MACH_NSLU2)$(CONFIG_VARIATIONS) += variation-nslu2.o
obj-x$(CONFIG_MACH_FSG3)$(CONFIG_VARIATIONS) += variation-fsg3.o
obj-$(CONFIG_INTERRUPTS)	+= exception_vectors.o

#obj-$(CONFIG_NPE)		+= npe.o npe-interface.o

#obj-$(CONFIG_DRIVER_IXP4XX_NPE_ETH) += drv-npe.o

obj-y				+= cmd-reset.o

obj-y += $(obj-xyy)

#libs-$(CONFIG_NPE) += _intel/lib/libnpeDl.a
#newlibs += $(obj)/_intel/lib/libnpeDl.a

#libs-$(CONFIG_NPE) := _intel/

=== debian/changelog ===
apex (1.6.10) unstable; urgency=critical

  * Change to usr/flash-apex to work-around change in shell that could cause script to fail. (Closes: #548236).

 -- Marc Singer <elf@debian.org>  Tue, 06 Oct 2009 18:45:07 -0700

apex (1.6.9) unstable; urgency=low

  * Including some entries from previous changlog to make sure bugs get
    closed.
  * Added CONFIG_AEABI=y to armel (and all configurations). (closes: #481848)
  * Added shlib dependencies for the sake of apex-env. (closes: #481846)
  * Revised copyright messages, again, to remove all references to the FSF
    address.
  * Removed FSF info from every file and point to debian/copyright file
    instead. (closes: #481843) (closes: #481736)
  * Removed rtc-x1205.probe=0,0x6f and rtc-pcf8563.probe=0,0x51 from
    kernel command lines. (closes: #471476) 
  * Removed warnings is usr/ tools build.
  * The --force option to apex-env was fixed in a previous release.
    (closes: #417757)

 -- Marc Singer <elf@buici.com>  Sun, 17 May 2009 18:10:37 -0700

apex (1.5.14) unstable; urgency=low

  * Added CONFIG_AEABI=y to armel. (closes: #481848)
  * Added shlib dependencies for the sake of apex-env. (closes: #481846)
  * Revised copyright messages, again, to remove all references to the FSF
    address.
  * debian/postinst: Fixed the postinst script to only run on the NSLU2.
    (closes: #482000)
  * The --force option to apex-env was fixed in a previous release.
    (closes: #417757)
  * Fixed the debian/copyright file to reflect the new wiki URL
    syntax. (closes: #481736)
  * Many upstream changes since last release, though most were not visible
    to nslu2. There was a bug fixed in the envronment handling where a
    broken environment region could cause unexpected boot-time problems.
  * Included Kevin Price's patch for flash-apex.
    o Added shlib dependencies for apex-env
    o Updated FSF address in copyright
    o Added manpage flash-apex(8)
    o Removed boot option `rtc-x1205.probe=0,0x6f' from kernel command
      line (closes: #471476)
    o -- Kevin Price <kp@kevin-price.de>  Tue, 16 May 2008 17:52:00 +0200
    o Bumped new upstream version
    o Enabled CONFIG_AEABI=y
    o [ Gordon Farquharson <gordonfarquharson@gmail.com> ]
    o CONFIG_RAMDISK_SIZE=0x005FFFF0 (closes: #451882)
    o Add flash-apex script. (closes: #421359)
    o Add postinst script to run flash-apex on installation.
  * Applied patches from rwhitby for Debian and slugos targets.
  * Added overrides support to allow 'every' target really build every
    configuration.

 -- Marc Singer <elf@buici.com>  Tue, 27 May 2008 19:58:03 -0700

apex (1.5.8) unstable; urgency=low

  * Added 'release' comand to the apex-env.
  * Defaults for debian configs will detect all memory.

 -- Marc Singer <elf@buici.com>  Mon, 25 Jun 2007 15:53:22 -0700

apex (1.5.7) unstable; urgency=low

  * Since last official release, fixes to the memory detection, AEABI
    support, OneNAND environment support with ENV_SAVEATONCE, lots of mx31
    changes, completely restructured the reset vector to avoid function
    calls, and lots of other stuff documented in the package ChangeLog.

 -- Marc Singer <elf@buici.com>  Sun, 24 Jun 2007 18:41:27 -0700

=== debian/control ===
Source: apex
Section: admin
Priority: optional
Maintainer: Marc Singer <elf@debian.org>
Standards-Version: 3.7.2
Build-Depends: perl, debhelper (>= 5)

Package: apex-nslu2
Architecture: arm armeb armel
Depends: devio, ${shlibs:Depends}
Description: APEX Boot Loader for Linksys NSLU2 
 The APEX Boot Loader is a modular and retargetable firmware loader
 suitable for embedded systems.  
 .
 This package is a version of APEX configured for the Linksys NSLU2
 network appliance.  In this case, APEX is used as a second stage
 loader so that Redboot, as installed by the manufacturer, may remain.
 . 
 The APEX command line offers a comfortable (e.g. command line editing
 and history) and extensible platform for development and production
 uses.
 .
 <http://wiki.buici.com/wiki/Apex_Bootloader>

=== debian/rules ===
#!/usr/bin/make -f

package = apex-nslu2
docdir = debian/tmp/usr/share/doc/$(package)

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
CONFIG	      := debian-nslu2-$(DEB_HOST_ARCH)_config

CC = gcc
CFLAGS = -g -Wall
INSTALL_PROGRAM = install


ifeq (arm,$(DEB_HOST_ARCH))
 ENDIAN:=l
endif
ifeq (armel,$(DEB_HOST_ARCH))
 ENDIAN:=l
endif
ifeq (armeb,$(DEB_HOST_ARCH))
 ENDIAN:=b
endif

# We must not change the build options.
#ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
#  CFLAGS += -O2
#endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
  INSTALL_PROGRAM += -s
endif

build:
	$(checkdir)
	$(MAKE) $(CONFIG)
	$(MAKE)
	$(MAKE) -C usr CROSS_COMPILE=
	touch build

clean:
	$(checkdir)
	rm -f build
	-$(MAKE) -i distclean
	rm -rf *~ debian/tmp debian/*~ debian/files* debian/substvars

binary-indep:	checkroot build
	$(checkdir)
# There are no architecture-independent files to be uploaded
# generated by this package.  If there were any they would be
# made here.

binary-arch:	checkroot build
	$(checkdir)
	rm -rf debian/$(package)
	dh_testroot -a
	dh_installdirs
	install -d debian/$(package)/boot
	install -d debian/$(package)/usr/sbin
	install -m 0644 src/arch-arm/rom/apex.bin\
		  debian/$(package)/boot/apex.flash
	install -m 0755 usr/apex-env debian/$(package)/usr/sbin
	install -m 0755 usr/flash-apex debian/$(package)/usr/sbin
	install -m 0755 usr/apex-image debian/$(package)/usr/sbin
	dh_strip
	dh_installchangelogs ChangeLog
	dh_installdocs -a
	dh_installman usr/apex-env.8
	dh_installman usr/flash-apex.8
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

define checkdir
	test -f src/apex/init.c -a -f debian/rules
endef

binary: binary-indep binary-arch

checkroot:
	$(checkdir)
	test $$(id -u) = 0

.PHONY: binary binary-arch binary-indep clean checkroot

## apex 1.6.10ubuntu3

=== Makefile ===
--- 
+++ 
@@ -343,7 +343,7 @@
 KBUILD_CFLAGS   := -Wall -Wundef -Wstrict-prototypes -Wno-trigraphs \
 		   -fno-strict-aliasing -fno-common \
 		   -Werror-implicit-function-declaration \
-		   -fno-builtin-printf
+		   -fno-builtin-printf -marm
 KBUILD_AFLAGS   := -D__ASSEMBLY__
 
 # Read KERNELRELEASE from include/config/kernel.release (if it exists)

=== debian/changelog ===
apex (1.6.10ubuntu3) lucid; urgency=low

  * Makefile: fix armel build failures by building with -marm;
    thx to ogra for this patch (LP:503090)
  * usr/link.cc: fix "link.cc:236: error: invalid conversion from
    ‘const char*’ to ‘char*’" - use a copy rather than constant to do
    the parsing etc. (LP:503090)

 -- Alexander Sack <asac@ubuntu.com>  Mon, 04 Jan 2010 20:24:21 +0100

apex (1.6.10ubuntu2) lucid; urgency=low

  * add -marm to CFLAGS to fix FTBFS

 -- Oliver Grawert <ogra@ubuntu.com>  Thu, 26 Nov 2009 16:15:47 +0100

apex (1.6.10ubuntu1) lucid; urgency=low

  * Merge from debian testing, remaining changes:
    - Move apex VMA address to 4MiB to leave enough space for the ubuntu
    kernel and not overwrite apex in ram when loading.
    - nslu2 configuration: set CONFIG_RAMDISK_SIZE=0x0055FFF0 instead of
    0x005FFFF0 to make enough room for ubuntu initramfs.

 -- Oliver Grawert <ogra@ubuntu.com>  Tue, 10 Nov 2009 11:55:15 +0100

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,9 @@
 CONFIG	      := debian-nslu2-$(DEB_HOST_ARCH)_config
 
 CC = gcc
-CFLAGS = -g -Wall
+CFLAGS = -g -Wall -marm
+# dpkg-buildpackage passes options that are incompatible with our build.
+unexport LDFLAGS
 INSTALL_PROGRAM = install
